
#include<cudpp.h>
#include<stdio.h>

// a wrapper to call the scan from cudpp
// here passing directly uints
void scanpass(uint *d_odata, uint* d_idata, uint numElements)
{
    CUDPPConfiguration config;
    config.op = CUDPP_ADD;
    config.datatype = CUDPP_UINT; // uint here
    config.algorithm = CUDPP_SCAN;
    config.options = CUDPP_OPTION_FORWARD | CUDPP_OPTION_EXCLUSIVE;
    
    CUDPPHandle scanplan = 0;
    CUDPPResult result = cudppPlan(&scanplan, config, numElements, 1, 0);  

    if (CUDPP_SUCCESS != result)
    {
        printf("Error creating CUDPPPlan\n");
        exit(-1);
    }

   // Run the scan
    cudppScan(scanplan, d_odata, d_idata, numElements);


/* must link with testrig and includes in there arraycompare.h
   // compute reference solution //float to uint here
    uint* reference = (uint*) malloc( memSize);
    computeSumScanGold( reference, h_idata, numElements, config);

    // check result
    CUTBoolean res = cutComparef( reference, h_odata, numElements);
    printf( "Test %s\n", (1 == res) ? "PASSED" : "FAILED");
*/


    result = cudppDestroyPlan(scanplan);
    if (CUDPP_SUCCESS != result)
    {
        printf("Error destroying CUDPPPlan\n");
        exit(-1);
    }
}

